#include "ast/type_info.hpp"
#include <string>
/**
* A class for storing information about the kind of symbol (e.x. function, variable, etc.)
*/

using namespace type_info;

Kind::Kind(){ value = KindValue::OTHER; }
Kind::Kind(KindValue kind){ value = kind; }

Kind::operator std::string() const {
    switch (value) {
        case KindValue::LABEL     : return "label";
        case KindValue::UNINITVAR : return "variable (uninitialized)";
        case KindValue::INITVAR   : return "variable (initialized)";
        case KindValue::VALUE     : return "value";
        case KindValue::FUNC      : return "function";
        case KindValue::FUNCARG   : return "function argument";
        case KindValue::OTHER     : return "other";
        default: return "unknown";
    }
}
