#include "util/pos.hpp"
#include <sstream>

using namespace util;

int Pos::linenum = 1;
int Pos::colnum = 1;
int Pos::line = 1;
int Pos::col = 1;

void Pos::setpos() { // set starting position for current token
    Pos::linenum = Pos::line;
    Pos::colnum = Pos::col;
}

void Pos::calcPos(std::string string) {
    std::stringstream newlineCounter = std::stringstream(string);

    // Grab the next line in the text
    std::string lastLine;
    std::getline(newlineCounter, lastLine, '\n');

    // Check if there is still more of the string
    bool multiline = newlineCounter.rdbuf()->in_avail() > 0;

    if(multiline) {
        // Go through the string to determine how many lines are crossed
        // to get to the end of the string
        while(newlineCounter.rdbuf()->in_avail() > 0) {
            std::getline(newlineCounter, lastLine, '\n');
            Pos::line += 1;
        }
        Pos::col = lastLine.length();
    }
    else {
        Pos::col += lastLine.length();
    }
}
